WinAgents RouterTweak Overview

 WinAgents RouterTweak

Overview

WinAgents RouterTweak is a special terminal shell making it easier to control the configuration of routers, switches and firewalls from the Cisco Systems, Inc. WinAgents RouterTweak makes the work of network administrators more effective by automating typical device configuration tasks.

Main program features:

  • Modifying device configurations in a visual way with syntax highlighting and context help.
  • Editing access control lists line by line.
  • Entering passwords automatically and switching to the privileged mode while connecting to devices.
  • Command line interface with highlighted syntax of Cisco commands.
  • Connecting to devices via the TELNET and SSH protocols or a COM port.
  • Working with all devices using Cisco IOS® Software or Cisco PIX® Firewall Software (version 6.3 or earlier).

For information about how to work with the program, see the corresponding documentation sections:

  • Basic principles
  • Connecting to the device
  • Main application window
  • Device configuration
  • Program options
  • Registration and technical support


Principles and advantages of the program

Once you connect to a device using WinAgents RouterTweak, you have a number of tools allowing you to make your work with Cisco routers and switches more visual and effective. Knowing the principles of working with the command line interface of Cisco devices, you can use WinAgents RouterTweak to automate the most common tasks of network device administration. This approach saves your time by allowing you to hand over routine operations to the program. Here is a number of benefits you get if you use WinAgents RouterTweak:

  • Reducing the time needed to connect to a device. Having specified the username and password for connecting to a device only once, you will not have to spend time on entering them again when you connect to your router next time. WinAgents RouterTweak will enter the account data itself and switch to the privileged mode if necessary.
  • Viewing the configuration of a device in a convenient form. Just click once to get the configuration of your device in a visual form. Syntax highlighting and the structure tree of the device configuration will allow you to quicker find your bearings among numerous configuration commands. For instance, all you need to do in order to switch to the settings of a certain interface is select this interface in the configuration tree.
  • Increasing the speed of work with access control lists (ACL). WinAgents RouterTweak allows you to do without a TFTP server while editing access control lists. You can add, edit and remove commands located in the middle of ACLs. The program knows about the peculiarities of using the command line interface for working with Cisco access control lists and takes them into account while editing ACLs.
  • Usability in editing the configuration of devices. It is easier to edit configuration commands due to the context help system. While you are adding a new command to the configuration file, WinAgents RouterTweak requests its possible parameters from the device. In the process of editing commands, you see the list of available variants for each command all the time and can select one of them without entering the entire string.
  • Usability in carrying out common tasks of Cisco device administration. Several mouse clicks are enough to print out the configuration of a device, copy it to a file or save it to NVRAM.

WinAgents RouterTweak offers you two ways to work with devices. You can use the terminal shell to work with the command line interface directly. In this case you will have a standard set of command line tools enhanced by syntax highlighting. Syntax highlighting makes it easier to find what you need in the results of executed commands, which makes your work more effective.

A more effective and faster method of editing the configuration of a device is using the built-in editor. In this case the program requests the configuration file from the device and allows you to edit it. Instead of you, the application will do everything necessary in the command line. And you will be able to focus on the device configuration using context help.

But it does not turn the application into a "black box". You are constantly in control of its actions and the results of your operations. To ensure that, the entire process of command exchange between the devices being configured and WinAgents RouterTweak is displayed in the terminal window.

Another convenient feature of WinAgents RouterTweak is the permanent availability of the window for terminal access to the device. Thus, you can combine the two methods of working with the device.


Connecting to the device

Immediately after you start the program, it displays the dialog box where you can specify the properties of the connection to the device. You can see a screenshot of this dialog box in Figure 1. Later you can use the Device->Connect... menu command to connect to a device.

Figure 1. Connection properties.

The following connection settings are available:

  • Device address - the network address or the name of the device
  • Automatically logon to device - log in automatically after the connection is established. If this option is enabled, the program will automatically enter the username and password for logging in to the device after the connection is established.
  • Username - the username used for logging in to the device.
  • Password - the password used for logging in to the device.
  • Enter privileged EXEC mode - automatically switch to the privileged mode after successful authentication on the device. If this option is selected, the program will execute the 'enable' command and enter the corresponding password after you are logged to the device.
  • Enable password - the password used to switch to the privileged mode (enable).
  • Automatically retrieve running configuration - automatically retrieve the running configuration from the device after switching to the privileged mode.
  • Connection type - the type of the connection to the device. It is possible to connect via the Telnet and SSH network protocols, as well as via a direct connection to the device using a cable connected to the COM port of the computer.
  • СOM port - if this connection type is used to connect to the device, the parameters of a COM connection become available. The set of COM port parameters is standard.
  • Save connection credentials - if this option is enabled, all connection properties will be saved. So you will not have to specify the settings when you connect to this device next time.

After you specify and confirm all the necessary parameters by clicking OK, an attempt to connect to the device will be made. If this operation is successful, the main window of RouterTweak will become available and you can start working with the device.

If in the process of working with the device the connection is broken for some reason, the program displays the Connection Properties dialog box again.


Main application window

The main window of the program appears on the screen after a connection to the device is established. The way this window looks like depends on the program settings and the current device status.

The main window of RouterTweak in its expanded form looks the way it is shown on the screenshot (Figure 2). It is divided into two main working areas. First of all, it is its central part with the configuration of the device and its tree presentation. The tree is necessary to visualize and enhance navigation through the device configuration file.

The console area occupies the lower part. As usual, the upper part of the program contains the toolbar.

Figure 2. Main application window

The working area of the application can be customized to provide maximum comfort for the user. You can do it by dragging splitters with your mouse.

Besides, you can hide the configuration area completely and make WinAgents RouterTweak look like a regular console. However, there are additional usability features even in this case.


Device configuration

The main advantage of WinAgents RouterTweak is that it is possible to visually edit the configuration files of devices manufactured by the Cisco Systems, Inc.

For detailed information about basic WinAgents RouterTweak operations, see the corresponding sections:

  • Retrieving the running and startup configurations
  • Editing the running configuration of a device
  • Adding a command
  • Editing a command
  • Deleting a command
  • Saving the configuration to NVRAM
  • Editing ACLs
  • Verbose mode


Retrieving the running and startup configurations

To retrieve the running or startup configuration from the device, you can use the Configuration->Show running/startup configuration menu commands or the corresponding toolbar buttons. These commands become available only when the user is connected to a device in the privileged mode. You can switch to this mode either using the enable terminal command or automatically by enabling the corresponding option in connection properties. Note that in both cases you should specify the password for switching to the privileged mode.

After you execute the Show running configuration command, you will see a panel with the running device configuration that you can edit. See the Editing the running configuration device section for details.

If you execute the Show startup configuration command, you will see the window with the startup configuration. In this case it is impossible edit the configuration directly. If you need to make changes in the startup configuration of the device, you should modify the running configuration first and then copy it to NVRAM. See the Saving configuration to NVRAM section for additional information.


Built-in configuration file editor

One of the main WinAgents RouterTweak features is a built-in editor of configuration files.

Figure 3. Editing the running configuration

The editor of configuration files built into WinAgents RouterTweak has the following features:

  • Editing the configuration in real time.
  • Displaying configuration commands as editable text lines, which makes editing them more natural and intuitive.
  • Automatically switching to the configuration mode and to the necessary configuration sublevel if needed.
  • Context list of possible commands with their description.
  • Context help for subcommands and parameters of the currently edited command.
  • Smart system of informing about errors and typos in commands.
  • Additional features for editing access lists.
  • Complete support of commands that have multiline strings in their parameters.

The abovementioned features supplement all functions typical of a regular terminal.

Besides, to make the configuration text more readable, the following features are used:

  • Highlighting key items (addresses, strings, numbers, etc.).
  • Presenting embedded configuration modes as a tree of embedded commands.
  • Highlighting recently edited commands in a special way.


Adding a command

Adding a command is one of the main operations in the process of editing the configuration of a device.

Before you add a new command, you should select a line in the running configuration to specify the place for the new command.

You can add a new command to the configuration using the Configuration->Add command or Configuration->Add command to mode menu item. Besides, you can use the corresponding toolbar buttons or hotkeys. Add command adds a new configuration mode to the same configuration mode after the selected one.

Add command to mode can be used only when you select a command that changes the configuration mode the command being added will belong to. Commands changing the configuration modes are highlighted (in dark blue by default).

Figure 4. Adding a command

For instance, in this case (Figure 4), selecting the Add command to mode item will add a new command configuring the selected interface right after the 'speed auto' command. At the same time, selecting the Add command item will add a new command in the global configuration mode to the same level where the 'interface' command is.

See detailed information about editing a command in the Editing a command section.

To make tracking changes easier, added commands are typed in italic and highlighted (in green by default). This highlighting remains until the configuration is refreshed or the connection to the device is reestablished.

Attention! After you refresh the configuration of the device using the Refresh command or reconnect to the device, the added command may change its position in the configuration file. It is normal because the device sorts configuration commands in its own way.


Editing a command

In the process of editing the configuration of a device, you often need to modify commands that already exist.

To start editing a command, you should select the corresponding line in the configuration text and select the Configuration->Edit command menu item. You can also use the corresponding hotkey and toolbar button.

Another way to start editing a command is to double-click it in the configuration.

Figure 5. Editing a command.

Tooltips and lists of possible commands/parameters help you in the process of editing commands. This help items automatically appear on the screen whenever necessary. If you need to open them manually, use the Ctrl+Space key combination.

Tooltips depend on context and inform you about the type and the purpose of the parameter you are editing at the moment.

The list of possible commands is used to speed up entering the necessary command. All you need to do to enter a command is select it from the list using either the keyboard or the mouse.

The list of possible commands also helps you complete partially typed commands automatically. Just type the first few characters until the necessary command is selected in the list and press Space. The selected command will be automatically added to the line.

Press Enter to finish editing. If there are no mistakes, the corresponding changes will be made in the device configuration and the command will become italic and highlighted (in green by default). This highlighting remains until the configuration is refreshed or the connection to the device is reestablished. If there is a mistake made in the command, you will see the corresponding message.

You can cancel editing the configuration line by pressing the Esc key or by a mouse click on any other object.

Attention! If you change some command completely, it may change its place in the configuration file after you refresh the configuration file using the Refresh command or reconnect to the device. It is normal because the device sorts configuration commands in its own way.

When you are editing a command, you may delete its entire text. It will have the same effect as if you reset the command to its default value, see the Negating and reverting commands to default section for details.


Negating and reverting commands to default

With WinAgents RouterTweak, it is much easier to negate commands and revert them to default. These operations are performed with several mouse clicks so there is no need to use the console. You do not have to monitor the correct configuration mode and type any text.

Negating commands

To disable some function on the device or just execute the command opposite to the existing one, you should negate the command.

To negate a command, you should select the corresponding line in the configuration text and use either the Configuration->Negate command menu item or the corresponding toolbar button or hotkey.

The device understands the Negate command operation as the same command with the no prefix.

To make tracking changes easier, commands reverted to default are typed in italic and highlighted (in green by default). This highlighting remains until the configuration is refreshed or the connection to the device is reestablished.

Attention! After you re-read the configuration of the device using the Refresh command or reconnect to the device, a command may completely disappear from the configuration if it completely coincides with its default.

Use Negate command once again to cancel negating a command.

Reverting a command to default

Almost all commands have defaults. If some commands are absent in the running configuration, it means that they are set to default.

To revert a command to default, you should select the corresponding line in the configuration text and use either the Configuration->Revert to default command menu item or the corresponding toolbar button or hotkey.

The device understands the Revert to default command operation as the same command with the default prefix.

To make tracking changes easier, commands reverted to default have a line through them and they are italic and highlighted (in green by default). This highlighting remains until the configuration is refreshed or the connection to the device is reestablished.

Attention! After you re-read the configuration of the device using the Refresh command or reconnect to the device, the command will be set to default and may completely disappear from the configuration.

Use Revert to default command once again to cancel reverting a command to default.


Saving the configuration to NVRAM

Changes applied to the running configuration will be reset after the device is reloaded. To save the changes, you should copy the running configuration to the Non-Volatile RAM (NVRAM) to the so-called startup configuration.

WinAgents RouterTweak allows you to do it with a mouse click. To do it, you should use the Save configuration to NVRAM toolbar button or the corresponding menu command.


Additional editing features

Editing ACL

It is fairly difficult to edit access control lists (ACL) on Cisco Systems devices. Unfortunately, there is no simple way to add a new rule to the middle of an access control list. There are also no simple ways to edit existing rules. In order to modify access control lists, network administrators have to load the configuration of a device to a TFTP server, edit it there and then copy it back to the device. You cannot say it is a simple approach. Besides, it is difficult to use this method if your device and the TFTP server are on different sides of NAT. Besides, copying the configuration of a device via the TFTP protocol is a treat to network security because the TFTP protocol does not encrypt transmitted data.

WinAgents RouterTweak allows you to edit ACLs without a TFTP server. You can use the device configuration editor to add, edit and remove lines from access control lists. The program uses the command line interface of Cisco devices to make the necessary changes in ACLs. WinAgents RouterTweak knows about the peculiarities of editing ACLs and takes them into account. For example, if you insert a new rule into the middle of an access control list, the program will follow the following sequence of actions:

  1. Delete the access control list.
  2. Create a new ACL and add all existing rules to it one by one. The new rule will be added to the list in the selected position.

All this is done automatically. You will only have to add a new rule to the necessary position in the access control list. You can see all commands the program executes during this process using the verbose mode.

Editing multiline strings in commands

Some commands can use multiline strings as their parameters. For example, these are commands setting the appearance of banners. You can add multiline commands the same as usual commands.


Verbose mode

When you edit the configuration directly, WinAgents RouterTweak takes upon itself the entire work with the console of the device. To be able to see the results of executed configuration commands, you should enable showing them in the console window. To do it, click the Show device output when editing configuration button on the toolbar. To disable showing commands on the screen, click this button once again.

The verbose mode allows you to see commands that are actually executed on the device.


Working with the terminal interface

Besides editing the device configuration directly, WinAgents RouterTweak allows you to work with the device using the built-in terminal. The use of the terminal does not differ from using any other software product providing terminal access to devices.

It is necessary to use the terminal when doing anything with the device other than configuring it. Most often it is displaying information/statistics about the device.

To make information displayed in the terminal window more readable, some of it is highlighted. Among such key items there are numbers, addresses, text fragments and so on. If necessary, this feature can be easily disabled.


Program options

You can access the options of the program using the Device->Program settings… menu item.

Figure 6. Program options

The Program Options dialog box contains three tabs:

  • General
    • Save information for last connections - the maximum number of devices in the history.
    • Connection timeout - defines the timeout for the session in seconds.
    • Save session log - enables logging records displayed in the console window to a file.
    • File name - defines the file used for logging if the Log session option is enabled.
  • Configuration Panel
    • Configuration colors - allows you to customize colors used for highlighting the configuration.
  • Terminal
    • Terminal width - allows you to specify the width of the terminal in characters.
    • Highlight syntax - allows you to customize colors for highlighting text in the terminal.


Starting WinAgents RouterTweak from the command line

You can start WinAgents RouterTweak from the Windows command line passing the following parameters to the program:

rtweak device_address [-n] [-u username] [-p password] [-e enable_password] [-s] [-r]

rtweak -c com_port [-u username] [-p password] [-e enable_password] [-r]

Command line parameters:

device_address - the DNS name or IP address of the device

com_port - the name of the COM port for connecting to the device.

-n - do not use the parameter from the connection history for connecting to the device.

-u username - username for authenticating on the device.

-p password - the password for authenticating on the device.

-e enable_password - the password for switching to the privileged mode.

-s - use the SSH protocol for connecting to the device (otherwise the TELNET protocol will be used).

-r - automatically retrieve the running configuration after the connection to the device is established.

-с - connect to the device via the COM port (the default port settings are used).


Ordering and Support

 Support

Support

Please feel free to send all your questions to support@winagents.com. Your feedbacks are welcome and will be forwarded to developers team. However we can not guarantee quick answer.

Please check our Product FAQs before you e-mail us your question or report your problem. It may have already been answered. Thanks.


Ordering and Support

 Disclaimer and Trademarks

Disclaimer and Trademarks

This software is provided on an "as is" basis without warranty of any kind, expressed or implied, including but not limited to the implied warranties of merchantability and fitness for a particular purpose. The person using the soft ware bears all risk as to the quality and performance of the software. The author will not be liable for any special, incidental, consequential, indirect or similar damages due to loss of data or any other reason, even if the author or an agent of the author has been advised of the possibility of such damages. In no event shall the author's liability for any damages ever exceed the price paid for the license to use the software, regardless of the form of the claim.

All Tandem Systems, Ltd. software products, (including but not limited to the WinAgents™ RouterTweak™), and/or other materials are not sponsored by, endorsed by or affiliated with Cisco Systems, Inc.

Cisco®, Cisco Systems®, IOS®, and PIX® are registered trademarks of Cisco Systems, Inc. in the United States and certain other countries.

WinAgents™, RouterTweak™ and WinAgents RouterTweak™ are trademarks of Tandem Systems, Ltd. in the United States and certain other countries.

All other trademarks are trademarks of their respective owners.